**miscdoc+**************************************************
************************************************************
**
** The key code definitions here are listed in numerical
** order.  All names begin with "kc" (to indicate a "k"ey 
** "c"ode), and names are chosen to best describe the primary
** operation of the key.
**
************************************************************
**+miscdoc**************************************************

DEFINE kcMenuKey1	ONE
DEFINE kcMenuKey2	TWO
DEFINE kcMenuKey3	THREE
DEFINE kcMenuKey4	FOUR
DEFINE kcMenuKey5	FIVE
DEFINE kcMenuKey6	SIX

*
* these keys do not exit with VGER
*
*DEFINE kcMathMenu	SEVEN
*DEFINE kcPrgmMenu	EIGHT
*DEFINE kcCustomMenu	NINE

DEFINE kcAPPS		SEVEN
DEFINE kcMODE		EIGHT
DEFINE kcTOOLS		NINE
DEFINE kcUpArrow	TEN

DEFINE kcVarsMenu	ELEVEN
DEFINE kcSto		TWELVE
DEFINE kcNextRow	THIRTEEN
DEFINE kcLeftArrow	FOURTEEN
DEFINE kcDownArrow	FIFTEEN
DEFINE kcRightArrow	SIXTEEN

DEFINE kcHIST		SEVENTEEN
DEFINE kcCAT		EIGHTEEN
DEFINE kcEQW		NINETEEN
DEFINE kcSYMB		TWENTY
DEFINE kcBackspace	TWENTYONE

DEFINE kcPower		TWENTYTWO
DEFINE kcSqrt		TWENTYTHREE
DEFINE kcSin		TWENTYFOUR
DEFINE kcCos		TWENTYFIVE
DEFINE kcTan		TWENTYSIX

*DEFINE kcTick		THIRTEEN
*DEFINE kcSto		FOURTEEN
*DEFINE kcEval		FIFTEEN

DEFINE kcEnterExp	TWENTYSEVEN
DEFINE kcNegate		TWENTYEIGHT
DEFINE kcXTDELTA	TWENTYNINE
DEFINE kcInverse	THIRTY
DEFINE kcDivide		THIRTYONE

DEFINE kcAlpha		THIRTYTWO
DEFINE kc7		THIRTYTHREE
DEFINE kc8		THIRTYFOUR
DEFINE kc9		THIRTYFIVE
DEFINE kcMultiply	THIRTYSIX

DEFINE kcLeftShift	THIRTYSEVEN
DEFINE kc4		THIRTYEIGHT
DEFINE kc5		THIRTYNINE
DEFINE kc6		FORTY
DEFINE kcMinus		FORTYONE

DEFINE kcRightShift	FORTYTWO
DEFINE kc1		FORTYTHREE
DEFINE kc2		FORTYFOUR
DEFINE kc3		FORTYFIVE
DEFINE kcPlus		FORTYSIX

DEFINE kcOn		FORTYSEVEN
DEFINE kc0		FORTYEIGHT
DEFINE kcPeriod		FORTYNINE
DEFINE kcSpace		FIFTY

DEFINE kcEnter		FIFTYONE

DEFINE kcAlphaLeft	FIFTY

xROMID 771
xTITLE MINEHUNT Conversion by DL 010405
xCONFIG CFG

ASSEMBLE
	CON(5)	#0C5D0
RPL
ExtPrg

ASSEMBLE
	CON(1)	8
RPL
xNAME MINEHUNT
::
 CK0
 XLIB_E7_33
;

LABEL CFG
::
 771 TOSRRP
;

** ExtPrg *******************************************************************
* Interface :   ( {} # --> {}' # )
* Description : This is the "extension program" for hooking into the '49G
*               choose menus. Menu #0 is the APPS, #8 the GAMES and RomID
*               LIBs menu.
*****************************************************************************
DEFINE ExtMesGames EIGHT
NULLNAME ExtPrg
::
  DUP ExtMesGames #= NOT?SEMI
  { $ "MINEHUNT" xMINEHUNT }
  3UNROLL
  SWAP#1+SWAP
;

NULLNAME XLIB_E3_63
CODE
	GOSBVL	=SAVPTR
	A=DAT1	A
	D1=A
	D1=D1+	5
	A=DAT1	A
	A=A-CON	A,9
	R2=A
	D1=D1+	5
	C=0	A
	C=DAT1	B
	R1=C
	D1=D1+	2
	A=0	A
	A=DAT1	B
	R0=A
	D1=D1+	2
	CD1EX
	RSTK=C
	GOSBVL	=makegrob
	C=RSTK
	CD0EX
	D1=C
	C=C-CON	A,15
	C=C-CON	A,5
	R0=C
	A=R2
	B=A	A
	A=0	A
L8200C	A=0	S
L8200F	B=B-1	A
	GOC	L82067
	A=DAT0	B
	B=B-1	A
	B=B-1	A
	D0=D0+	2
	?ABIT=0	7
	GOYES	L82070
	ABIT=0	7
	C=DAT0	1
	?A=0	S
	GOYES	L8203F
	DAT1=C	B
	D1=D1+	2
	A=A-1	B
	GOC	L8200C
L8203F	CSL	B
	C=DAT0	1
	D0=D0+	1
L82049	A=A-1	B
	GOC	L8205E
	DAT1=C	B
	D1=D1+	2
	A=A-1	B
	GONC	L82049
	GOC	L8200C
L8205E	A=0	S
	A=A-1	S
	GOC	L8200F
L82067	P=	0
	GOVLNG	=GPOverWrR0Lp
L82070	B=B-A	A
	?A#0	S
	GOYES	L82087
L82077	C=DAT0	1
	D0=D0+	1
	CSL	B
	A=A-1	B
	GOC	L8205E
L82087	C=DAT0	1
	D0=D0+	1
	DAT1=C	B
	D1=D1+	2
	A=A-1	B
	GONC	L82077
	GOTO	L8200C
ENDCODE

NULLNAME XLIB_E7_2E ( NULLNAME )
::
 '
 LAM 'MF1
 STO
;

NULLNAME XLIB_E7_2F ( NULLNAME )
::
 '
 LAM 'MF2
 STO
;

NULLNAME XLIB_E7_30 ( NULLNAME )
::
 '
 LAM 'MF3
 STO
;

NULLNAME XLIB_E7_31 ( NULLNAME )
::
 '
 LAM 'MF4
 STO
;

NULLNAME XLIB_E7_32 ( NULLNAME )
::
 '
 LAM 'MF5
 STO
;

NULLNAME XLIB_E7_33 ( NULLNAME )
* MINE
::
	UnLockAlpha
	RECLAIMDISP
	POLSaveUI
	ERRSET
	::
	ClrDA1IsStat
	ZERO
ASSEMBLE
	CON(5)  =DOCSTR
	REL(5)  L_81321
	NIBASC  '0000000000000000'
	NIBASC	'000000000000000'
	NIBASC	'000000000'
	NIBASC  '000000000000000'
	NIBASC	'0000000000000000'
	NIBASC	'000000000'
	NIBASC  '00000000000000000'
	NIBASC	'000000000000000000'
	NIBASC	'00000'
	NIBASC  '00000000'
L_81321
RPL
	TOTEMPOB
	ONEONE
	FALSE
	{
NULLNAME XLIB_E7_34 ( NULLNAME )
	LAM 'MF5
NULLNAME XLIB_E7_35 ( NULLNAME )
	LAM 'MF4
NULLNAME XLIB_E7_36 ( NULLNAME )
	LAM 'MF3
NULLNAME XLIB_E7_37 ( NULLNAME )
	LAM 'MF2
NULLNAME XLIB_E7_38 ( NULLNAME )
	LAM 'MF1
	;
	BIND
	XLIB_E7_57
	ITE
	::
	 INCOMPDROP
	 XLIB_E7_31
	 XLIB_E7_32
	 XLIB_E7_30
	 XLIB_E7_2F
	 HARDBUFF
	 ZEROZERO
	 TURNMENUOFF
	 GROB!
	;
	::
	 ZERO
	 ONE
NULLNAME XLIB_E7_39 ( NULLNAME )
ASSEMBLE
	 CON(5)  =DOHSTR
	 REL(5)  L_814E2
	 NIBHEX  F30111D8013800FC000201FC5901144006C00540
	 NIBHEX  0440044580117C001000100010007C5801144004
	 NIBHEX  C005400640044580117C0004003C0004007C5801
	 NIBHEX  1440044007C00440044580114400440044004400
	 NIBHEX  385801144004C005400640044580417C00100010
	 NIBHEX  00100010001E80707C00FE00
L_814E2
RPL
	 XLIB_E3_63
	 XYGROBDISP
	 # 78
	 ONE
NULLNAME XLIB_E7_3A ( NULLNAME )
ASSEMBLE
	 CON(5)  =DOHSTR
	 REL(5)  L_815F4
	 NIBHEX  F30131DC00E000F8010402F801390F71001B0015
	 NIBHEX  001100110010000F001400040004000F00100001
	 NIBHEX  00130015001900110010000F0011000F0001000F
	 NIBHEX  001000010011001F001100110010000100110018
	 NIBHEX  010011001E680C2100130015001900110010000F
	 NIBHEX  00140004000400040004E8070F001F803
L_815F4
RPL
	 XLIB_E3_63
	 XYGROBDISP
	 TURNMENUOFF
	 TEN
	 ONE_DO
          NINE
	  INDEX@
	  #1-
	  SEVEN
	  #*
	  SEVEN
	  #+
	  # 78
	  OVER
	  LINEON
	 LOOP
	 EIGHTEEN
	 ONE_DO
	  INDEX@
	  #1-
	  SEVEN
	  #*
	  NINE
	  #+
	  SEVEN
	  OVER
	  SIXTYTHREE
	LINEON
	LOOP
	XLIB_E7_53
	HARDBUFF
	BINT_115d
	FIFTYSEVEN
	GROB!
	SysTime
	HXS>#
	UNCOERCE
	DORANDOMIZE
	XLIB_E7_35
	'
 ID Nmines
 SAFE@
 ITE
 ::
  DUPTYPEREAL?
  ITE
  ::
   %ABSCOERCE
   DUP
*   64
   SIXTYFOUR
   #>
   IT
   ::
    DROP
*    64
    SIXTYFOUR
   ;
  ;
  ::
   DROP
   TWENTY
  ;
 ;
 TWENTY
 #1+_ONE_DO
 BEGIN
 %RAN
 % 124
 %*
 COERCE
 #2+
 2DUP
 SUB$1#
 FORTYEIGHT
 #<>
 WHILE
  DROP
 REPEAT
 FORTYNINE
 XLIB_E7_51
 LOOP
 XLIB_E7_31
 '
 ID Nmines
 SAFE@
 NOT?SEMI
 DUPTYPEREAL?
 ITE
 ::
  %0<
  IT
   XLIB_E7_3D
 ;
 DROP
;

XLIB_E7_41
	'
	XLIB_E7_3E
	RESOROMP
	XLIB_E7_44
	TrueTrue
	FALSE
	ZEROFALSE
	'
	LAM 'MF1
	'ERRJMP
	POLSetUI
	POLKeyUI
	ABND
	;
	ERRTRAP
	POLResUI&Err
	POLRestoreUI
;

NULLNAME XLIB_E7_3B ( NULLNAME )
::
 # E705 ( You blew up )
 JstGETTHEMSG
 XLIB_E7_43
 SIXTEEN
 EIGHT
 XLIB_E7_3F
 XLIB_E7_55
 XYGROBDISP
 XLIB_E7_3D
 SetDAsTemp
 XLIB_E7_4E
;
NULLNAME XLIB_E7_3C ( NULLNAME )
::
 # E706 ( You made it!! )
 JstGETTHEMSG
 XLIB_E7_43
 XLIB_E7_3F
 XLIB_E7_54
 XYGROBDISP
 XLIB_E7_3D
 SetDAsTemp
 XLIB_E7_4E
;

NULLNAME XLIB_E7_3D ( NULLNAME )
::
 NINE
 ONE_DO
 SEVENTEEN
 ONE_DO
  INDEX@
  JINDEX@
  2DUP
  XLIB_E7_4F
  FORTYNINE
  #=ITE
  ::
 HARDBUFF
 UNROT
 XLIB_E7_52
 4UNROLL
 XLIB_E7_3F
 GROB!
  ;
  2DROP
 LOOP
 LOOP
 ;

NULLNAME XLIB_E7_3E ( NULLNAME )
::
 XLIB_E7_37
 XLIB_E7_36
 ZERO
 UNROT
 DUPDUP
 EIGHT
 #<>
 IT
 #1+
 #1+
 SWAPDUP
 #1<>
 IT
 #1-
 ROTDUP
 DUP
 SIXTEEN
 #<>
 IT
 #1+
 #1+
 SWAPDUP
 #1<>
 IT
 #1-
 DO
 ROT
 3PICK3PICK
 DO
  JINDEX@
  INDEX@
  XLIB_E7_4F
  FORTYNINE
  #=
  IT
  #1+
 LOOP
 UNROT
 LOOP
 2DROP
 # E701 ( Near )
 JstGETTHEMSG
 SWAP
 DUP
 #1=
 ITE
 # E702
 # E703
 JstGETTHEMSG
 SWAP
 #>$
 SWAP
 &$
 &$
 XLIB_E7_43
;

NULLNAME XLIB_E7_3F ( NULLNAME )
::
	#1-
	SEVEN
	#*
	#8+
	SWAPONE
	#-
	SEVEN
	#*
	#10+
	SWAP
;

NULLNAME XLIB_E7_40 ( NULLNAME )
::
	XLIB_E7_37
	XLIB_E7_36
	XLIB_E7_3F
	SIX
	SIX
	MAKEGROB
	INVGROB
	XYGROBDISP
;

NULLNAME XLIB_E7_41 ( NULLNAME )
::
	XLIB_E7_37
	XLIB_E7_36
	2DUP
	XLIB_E7_4F
	DUP
	FORTYNINE
	#=
	casedrop
	::
	2DUP
	FIFTYONE
	XLIB_E7_50
	XLIB_E7_3C
	;
	FORTYEIGHT
	#=
	IT
	::
	XLIB_E7_42
	2DUP
	FIFTY
	XLIB_E7_50
	;
	2DUP
	HARDBUFF
	UNROT
	XLIB_E7_52
	TOTEMPOB
	INVGROB
	4UNROLL
	XLIB_E7_3F
	GROB!
	EIGHT
	#=
	SWAP
	SIXTEEN
	#=
	ANDcase
	XLIB_E7_3B
;

NULLNAME XLIB_E7_42 ( NULLNAME )
::
	XLIB_E7_34
	#1+
	XLIB_E7_32
;

NULLNAME XLIB_E7_43 ( NULLNAME )
::
 # E704
 JstGETTHEMSG
 XLIB_E7_34
 #>$
 &$
 &$
 $>grob
 DUPGROBDIM
 SWAPDROP
 DUP
 # 6D
 #>
 IT
 ::
  DROP
  ZEROZERO
  # 6D
  SIX
  SUBGROB
  # 6D
 ;
 # 6D
 SWAP#-
 #2/
 ELEVEN
 #+
 ZERO
 ROT
 SIX
 # 6D
 MAKEGROB
 HARDBUFF
 ELEVEN
 ZERO
 GROB!
 XYGROBDISP
;

NULLNAME XLIB_E7_44 ( NULLNAME )
::
 ONE
 #=casedrop
 ::
  kcUpArrow
  ?CaseRomptr@
   XLIB_E7_46
  kc8
  ?CaseRomptr@
   XLIB_E7_46
  kcLeftArrow
  ?CaseRomptr@
   XLIB_E7_47
  kc4
  ?CaseRomptr@
   XLIB_E7_47
  kcDownArrow
  ?CaseRomptr@
   XLIB_E7_48
  kc2
  ?CaseRomptr@
   XLIB_E7_48
  kcRightArrow
  ?CaseRomptr@
   XLIB_E7_4D
  kc6
  ?CaseRomptr@
   XLIB_E7_4D
  kc7
  ?CaseRomptr@
   XLIB_E7_49
  kc9
  ?CaseRomptr@
   XLIB_E7_4A
  kc1
  ?CaseRomptr@
   XLIB_E7_4B
  kc3
  ?CaseRomptr@
   XLIB_E7_4C
  kcSto
  ?CaseRomptr@
   XLIB_E7_56
  kcLeftShift
  #=casedrpfls
  kcRightShift
  #=casedrpfls
  kcOn
  ?CaseRomptr@
   XLIB_E7_45
  DROP
  'DoBadKeyT
 ;
 THREE
 #=casedrop
 ::
  kcOn
  #=casedrpfls
  DROP
  'DoBadKeyT
 ;
 2DROP
 'DoBadKeyT
; 

NULLNAME XLIB_E7_45 ( NULLNAME )
::
 TakeOver
 ClrDAsOK
 XLIB_E7_4E
;
 
NULLNAME XLIB_E7_46 ( NULLNAME )
::
	TakeOver
	XLIB_E7_40
	XLIB_E7_36
	#1-
	DUP#0=
	ITE
	::
	DROP
	DoBadKey
	;
	XLIB_E7_30
	XLIB_E7_41
;

NULLNAME XLIB_E7_47 ( NULLNAME )
::
	TakeOver
	XLIB_E7_40
	XLIB_E7_37
	#1-
	DUP#0=
	ITE
	::
	DROP
	DoBadKey
	;
	XLIB_E7_2F
	XLIB_E7_41
;

NULLNAME XLIB_E7_48 ( NULLNAME )
::
	TakeOver
	XLIB_E7_40
	XLIB_E7_36
	#1+DUP
	NINE
	#=ITE
	::
	DROP
	DoBadKey
	;
	XLIB_E7_30
	XLIB_E7_41
;

NULLNAME XLIB_E7_49 ( NULLNAME )
::
	TakeOver
	XLIB_E7_37
	DUP
	#1=
	casedrop
	DoBadKey
	XLIB_E7_36
	DUP
	#1=
	case2drop
	DoBadKey
	XLIB_E7_40
	#1-
	XLIB_E7_30
	#1-
	XLIB_E7_2F
	XLIB_E7_41
;

NULLNAME XLIB_E7_4A ( NULLNAME )
::
	TakeOver
	XLIB_E7_37
	DUP
	SIXTEEN
	#=
	casedrop
	DoBadKey
	XLIB_E7_36
	DUP
	#1=
	case2drop
	DoBadKey
	XLIB_E7_40
	#1-
	XLIB_E7_30
	#1+
	XLIB_E7_2F
	XLIB_E7_41
;

NULLNAME XLIB_E7_4B ( NULLNAME )
::
	TakeOver
	XLIB_E7_37
	DUP
	#1=
	casedrop
	DoBadKey
	XLIB_E7_36
	DUP
	EIGHT
	#=
	case2drop
	DoBadKey
	XLIB_E7_40
	#1+
	XLIB_E7_30
	#1-
	XLIB_E7_2F
	XLIB_E7_41
;

NULLNAME XLIB_E7_4C ( NULLNAME )
::
	TakeOver
	XLIB_E7_37
	DUP
	SIXTEEN
	#=
	casedrop
	DoBadKey
	XLIB_E7_36
	DUP
	EIGHT
	#=
	case2drop
	DoBadKey
	XLIB_E7_40
	#1+
	XLIB_E7_30
	#1+
	XLIB_E7_2F
	XLIB_E7_41
;

NULLNAME XLIB_E7_4D ( NULLNAME )
::
	TakeOver
	XLIB_E7_40
	XLIB_E7_37
	#1+
	DUP
	SEVENTEEN
	#=ITE
	::
	DROP
	DoBadKey
	;
	XLIB_E7_2F
	XLIB_E7_41
;

NULLNAME XLIB_E7_4E ( NULLNAME )
::
	TakeOver
	TRUE
	XLIB_E7_2E
;

NULLNAME XLIB_E7_4F ( NULLNAME )
::
	#1-
	SIXTEEN
	#*
	#+
	XLIB_E7_35
	SWAP
	SUB$1#
;

NULLNAME XLIB_E7_50 ( NULLNAME )
::
	UNROT
	#1-
	SIXTEEN
	#*
	#+
	XLIB_E7_35
	UNROTSWAP
	XLIB_E7_51
	XLIB_E7_31
;

NULLNAME XLIB_E7_51 ( NULLNAME )
CODE
	GOSBVL  =POP#
	R0=A
	GOSBVL  =POP#
	R1=A
	GOSBVL  =SAVPTR
	A=DAT1  A
	LC(5)   8
	A=A+C   A
	C=R1
	A=A+C   A
	A=A+C   A
	D1=A
	C=R0
	DAT1=C  B
	GOVLNG	=GETPTRLOOP
ENDCODE

NULLNAME XLIB_E7_52 ( NULLNAME )
ASSEMBLE
	CON(5)  =DOGROB
	REL(5)  LIB_E7_53
	CON(5)  #6
	CON(5)  #6
	NIBHEX  00
	NIBHEX  C0
	NIBHEX  E1
	NIBHEX  E1
	NIBHEX  C0
	NIBHEX  00
LIB_E7_53
RPL
NULLNAME XLIB_E7_53 ( NULLNAME )
ASSEMBLE
	CON(5)  =DOGROB
	REL(5)  LIB_E7_54
	CON(5)  #6
	CON(5)  #6
	NIBHEX  51
	NIBHEX  A2
	NIBHEX  51
	NIBHEX  A2
	NIBHEX  51
	NIBHEX  A2
LIB_E7_54
RPL
NULLNAME XLIB_E7_54 ( NULLNAME )
ASSEMBLE
	CON(5)  =DOGROB
	REL(5)  LIB_E7_55
	CON(5)  #6
	CON(5)  #6
	NIBHEX  12
	NIBHEX  21
	NIBHEX  C0
	NIBHEX  C0
	NIBHEX  21
	NIBHEX  12
LIB_E7_55
RPL
NULLNAME XLIB_E7_55 ( NULLNAME )
ASSEMBLE
	CON(5)  =DOGROB
	REL(5)  LIB_E7_56
	CON(5)  #6
	CON(5)  #6
	NIBHEX  00
	NIBHEX  21
	NIBHEX  00
	NIBHEX  21
	NIBHEX  C0
	NIBHEX  00
LIB_E7_56
RPL
NULLNAME XLIB_E7_56 ( NULLNAME )
::
	HARDBUFF
	XLIB_E7_37
	XLIB_E7_36
	XLIB_E7_34
	XLIB_E7_35
	FIVE
	{}N
	# 303
	SWAP
	TWO{}N
	DUP
	OSIZE
CODE
	GOSBVL  =POP#
	R1=A
	GOSBVL  =SAVPTR
	A=DAT1  A
	D1=A
	LC(5)   =DOEXT0
	DAT1=C  A
	D1=D1+  5
	C=R1
	C=C-CON A,5
	DAT1=C  A
	GOVLNG	=GETPTRLOOP
ENDCODE
	'
	ID MHpar
	XEQSTOID
	XLIB_E7_4E
	ClrDAsOK
;

NULLNAME XLIB_E7_57 ( NULLNAME )
::
 '
 ID MHpar
 SAFE@
 DUP
 casedrop
 ::
  TOTEMPOB
  DUP
  XLIB_E7_58
  NOTcasedrop
  FALSE
  CODE
	C=DAT1  A
	CD1EX
	RSTK=C
	D1=D1+  10
	A=DAT1  A
	LC(5)   #303
	?A#C	A
	GOYES   L_82616
	D1=D1-  10
	LC(5)   =DOLIST
	DAT1=C  A
	D1=D1+  5
	LC(5)   =DOBINT
	DAT1=C  A
L_82616 C=RSTK
	D1=C
	GOVLNG  =PushF/TLoop
ENDCODE
  NOTcasedrop
  FALSE
  INCOMPDROP
  SWAPDROP
  TRUE
  '
  ID MHpar
  PURGE
 ;
;

NULLNAME XLIB_E7_58 ( NULLNAME )
CODE
	C=DAT1  A
	CD1EX
	A=DAT1  A
	D1=C
	LC(5)   =DOEXT0
	?A=C	A
	GOYES   L_8269C
L_8269C	GOVLNG	=OverWrT/FLp
ENDCODE
